package combinatorParsing2

/** An interface for streams of values which hav positions 
 */
abstract class Reader[+T] {

   /** Returns the first element of the stream 
    */
  def first: T

  /** Returns an abstract reader consisting of all elements except the first 
   */
  def rest: Reader[T]

  /** The position of the first element in the stream
   */
  def pos: Position

  def atEnd: boolean
}
