package combinatorParsing2
import scala.collection.mutable.HashSet

trait Scanners extends Parsers with Tokens {
  type Elem = char

  def token: Parser[Token]
  def whitespace: Parser[Any]

  class Scanner(in: Reader[char]) extends Reader[Token] {
    def this(in: String) = this(new CharArrayReader(in.toCharArray()))
    private val Triple(tok, rest1, rest2) = whitespace(in) match {
      case Success(_, in1) => 
        token(in1) match {
          case Success(tok, in2) => Triple(tok, in1, in2)
          case Failure(msg, in2) => Triple(errorToken(msg), in2, skip(in2))
        } 
      case Failure(msg, in1) => Triple(errorToken(msg), in1, skip(in1))
    }
    private def skip(in: Reader[char]) = if (in.atEnd) in else in.rest

    def first = tok
    def rest = new Scanner(rest2)
    def pos = rest1.pos
    def atEnd = in.atEnd
  }
}

