package combinatorParsing2

import collection.Set

/** This trait defines the standard token classes
 *  Token classes have two curried argument lists.
 *  The first argument list gives information specific to each token.
 *  The second argument list gives the token's position.
 *  That way, positions do not form part of patterns over tokens.
 *  Instead, use `t.pos' to get the position of token `t'.
 */
trait Tokens {
  type Token
  def errorToken(msg: String): Token 
}
